<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kd7w2jm6rvvx6pnfgbmafdxkx875y5cf-vendored-sources/syn-1.0.98/src/file.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>file.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../syn/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../syn/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../syn/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="kw">super</span>::<span class="kw-2">*</span>;

<span class="macro">ast_struct!</span> {
    <span class="doccomment">/// A complete file of Rust source code.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// *This type is available only if Syn is built with the `&quot;full&quot;` feature.*</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Example</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Parse a Rust source file into a `syn::File` and print out a debug</span>
    <span class="doccomment">/// representation of the syntax tree.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// use std::env;</span>
    <span class="doccomment">/// use std::fs::File;</span>
    <span class="doccomment">/// use std::io::Read;</span>
    <span class="doccomment">/// use std::process;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// fn main() {</span>
    <span class="doccomment">/// # }</span>
    <span class="doccomment">/// #</span>
    <span class="doccomment">/// # fn fake_main() {</span>
    <span class="doccomment">///     let mut args = env::args();</span>
    <span class="doccomment">///     let _ = args.next(); // executable name</span>
    <span class="doccomment">///</span>
    <span class="doccomment">///     let filename = match (args.next(), args.next()) {</span>
    <span class="doccomment">///         (Some(filename), None) =&gt; filename,</span>
    <span class="doccomment">///         _ =&gt; {</span>
    <span class="doccomment">///             eprintln!(&quot;Usage: dump-syntax path/to/filename.rs&quot;);</span>
    <span class="doccomment">///             process::exit(1);</span>
    <span class="doccomment">///         }</span>
    <span class="doccomment">///     };</span>
    <span class="doccomment">///</span>
    <span class="doccomment">///     let mut file = File::open(&amp;filename).expect(&quot;Unable to open file&quot;);</span>
    <span class="doccomment">///</span>
    <span class="doccomment">///     let mut src = String::new();</span>
    <span class="doccomment">///     file.read_to_string(&amp;mut src).expect(&quot;Unable to read file&quot;);</span>
    <span class="doccomment">///</span>
    <span class="doccomment">///     let syntax = syn::parse_file(&amp;src).expect(&quot;Unable to parse file&quot;);</span>
    <span class="doccomment">///</span>
    <span class="doccomment">///     // Debug impl is available if Syn is built with &quot;extra-traits&quot; feature.</span>
    <span class="doccomment">///     println!(&quot;{:#?}&quot;, syntax);</span>
    <span class="doccomment">/// }</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Running with its own source code as input, this program prints output</span>
    <span class="doccomment">/// that begins with:</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```text</span>
    <span class="doccomment">/// File {</span>
    <span class="doccomment">///     shebang: None,</span>
    <span class="doccomment">///     attrs: [],</span>
    <span class="doccomment">///     items: [</span>
    <span class="doccomment">///         Use(</span>
    <span class="doccomment">///             ItemUse {</span>
    <span class="doccomment">///                 attrs: [],</span>
    <span class="doccomment">///                 vis: Inherited,</span>
    <span class="doccomment">///                 use_token: Use,</span>
    <span class="doccomment">///                 leading_colon: None,</span>
    <span class="doccomment">///                 tree: Path(</span>
    <span class="doccomment">///                     UsePath {</span>
    <span class="doccomment">///                         ident: Ident(</span>
    <span class="doccomment">///                             std,</span>
    <span class="doccomment">///                         ),</span>
    <span class="doccomment">///                         colon2_token: Colon2,</span>
    <span class="doccomment">///                         tree: Name(</span>
    <span class="doccomment">///                             UseName {</span>
    <span class="doccomment">///                                 ident: Ident(</span>
    <span class="doccomment">///                                     env,</span>
    <span class="doccomment">///                                 ),</span>
    <span class="doccomment">///                             },</span>
    <span class="doccomment">///                         ),</span>
    <span class="doccomment">///                     },</span>
    <span class="doccomment">///                 ),</span>
    <span class="doccomment">///                 semi_token: Semi,</span>
    <span class="doccomment">///             },</span>
    <span class="doccomment">///         ),</span>
    <span class="doccomment">/// ...</span>
    <span class="doccomment">/// ```</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">doc_cfg</span>, <span class="ident">doc</span>(<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;full&quot;</span>)))]</span>
    <span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">File</span> {
        <span class="kw">pub</span> <span class="ident">shebang</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span>,
        <span class="kw">pub</span> <span class="ident">attrs</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Attribute</span><span class="op">&gt;</span>,
        <span class="kw">pub</span> <span class="ident">items</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Item</span><span class="op">&gt;</span>,
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;parsing&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">parsing</span> {
    <span class="kw">use</span> <span class="kw">super</span>::<span class="kw-2">*</span>;
    <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::parse</span>::{<span class="ident">Parse</span>, <span class="ident">ParseStream</span>, <span class="prelude-ty">Result</span>};

    <span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">doc_cfg</span>, <span class="ident">doc</span>(<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;parsing&quot;</span>)))]</span>
    <span class="kw">impl</span> <span class="ident">Parse</span> <span class="kw">for</span> <span class="ident">File</span> {
        <span class="kw">fn</span> <span class="ident">parse</span>(<span class="ident">input</span>: <span class="ident">ParseStream</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span><span class="op">&gt;</span> {
            <span class="prelude-val">Ok</span>(<span class="ident">File</span> {
                <span class="ident">shebang</span>: <span class="prelude-val">None</span>,
                <span class="ident">attrs</span>: <span class="ident">input</span>.<span class="ident">call</span>(<span class="ident">Attribute::parse_inner</span>)<span class="question-mark">?</span>,
                <span class="ident">items</span>: {
                    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">items</span> <span class="op">=</span> <span class="ident">Vec::new</span>();
                    <span class="kw">while</span> <span class="op">!</span><span class="ident">input</span>.<span class="ident">is_empty</span>() {
                        <span class="ident">items</span>.<span class="ident">push</span>(<span class="ident">input</span>.<span class="ident">parse</span>()<span class="question-mark">?</span>);
                    }
                    <span class="ident">items</span>
                },
            })
        }
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;printing&quot;</span>)]</span>
<span class="kw">mod</span> <span class="ident">printing</span> {
    <span class="kw">use</span> <span class="kw">super</span>::<span class="kw-2">*</span>;
    <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::attr::FilterAttrs</span>;
    <span class="kw">use</span> <span class="ident">proc_macro2::TokenStream</span>;
    <span class="kw">use</span> <span class="ident">quote</span>::{<span class="ident">ToTokens</span>, <span class="ident">TokenStreamExt</span>};

    <span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">doc_cfg</span>, <span class="ident">doc</span>(<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;printing&quot;</span>)))]</span>
    <span class="kw">impl</span> <span class="ident">ToTokens</span> <span class="kw">for</span> <span class="ident">File</span> {
        <span class="kw">fn</span> <span class="ident">to_tokens</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">tokens</span>: <span class="kw-2">&amp;mut</span> <span class="ident">TokenStream</span>) {
            <span class="ident">tokens</span>.<span class="ident">append_all</span>(<span class="self">self</span>.<span class="ident">attrs</span>.<span class="ident">inner</span>());
            <span class="ident">tokens</span>.<span class="ident">append_all</span>(<span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">items</span>);
        }
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="syn" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>